<?php
 /*
  * php+gd dynamic progress bar image script.
  * copyright 2003, B. Johannessen <bob@db.org>
  * modified for Mambo September 2004 Chris Meichtry (chris@drcorbeille.ch)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version, and provided that the above
  * copyright and permission notice is included with all distributed
  * copies of this or derived software.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * A copy of the GNU General Public License is available from the GNU
  * website at the following URL: http://www.gnu.org/licenses/gpl.txt
  *
  */
  //adaped by sumotoy
	if ((dirname($_SERVER['PHP_SELF']) == '\\' || dirname($_SERVER['PHP_SELF']) == '/')) {
		$style_dir = 'http://'.$_SERVER['HTTP_HOST'].'/images/';
	} else {					// Hosted in sub-directory.
		$style_dir = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/images/';
	}
 $style = $_REQUEST['style'];
 $width = $_REQUEST['width'];
 $done = $_REQUEST['data'];
 $total = $_REQUEST['max'];
 if (!is_numeric($total)) error('504 Service Unavailable', 'max parameter incorrect');
 if (!is_numeric($done)) error('505 Service Unavailable', 'data parameter incorrect');
 if (!is_numeric($width)) error('506 Service Unavailable', 'width parameter incorrect');
 $bg       = @imagecreatefrompng($style_dir.$style.'-bg.png');
 $fill     = @imagecreatefrompng($style_dir.$style.'-fill.png');
 $bg_cap   = @imagecreatefrompng($style_dir.$style.'-bg-cap.png');
 $fill_cap = @imagecreatefrompng($style_dir.$style.'-fill-cap.png');
 if(!$bg || !$fill || !$bg_cap || !$fill_cap) error('503 Service Unavailable', 'Error reading fragments');
 $fill_width = round((($width - imagesx($bg_cap)) * $done) / $total) - imagesx($fill_cap);
 $image = imagecreatetruecolor($width,imagesy($bg));
 imagecopy($image,$bg,0,0,0,0,imagesx($bg),$width - imagesx($bg_cap));
 imagecopy($image,$bg_cap, $width - imagesx($bg_cap), 0, 0, 0, imagesx($bg_cap), imagesy($bg_cap));
 imagecopy($image,$fill,0,0,0,0,$fill_width,imagesy($fill));
 imagecopy($image,$fill_cap,$fill_width,0,0,0,imagesx($fill_cap),imagesy($fill_cap));
 header("Content-Type: image/png");
 imagepng($image);
 imagedestroy($bg);
 imagedestroy($fill);
 imagedestroy($bg_cap);
 imagedestroy($fill_cap);
 imagedestroy($image);


 function error($code, $desc) {
  header($_SERVER['SERVER_PROTOCOL'] . ' ' . $code);
  if(strtoupper($_SERVER['REQUEST_METHOD']) != 'HEAD') {
   echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
   echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n";
   echo '<html xml:lang="en" lang="en">';
   echo '<head><title>' . $code . '</title></head><body><h1>'.$code.'</h1><p>'.$desc.'</p></body></html>';
  }
  exit;
 }
?>
